﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace List_Files
{
    class Program
    {
        static void Main(string[] args)
        {
            string directoryName = "A subdirectory";
            string fileName = @"C:\MyNewFile.txt";
            string binFileName = @"C:\MyNewBinFile.bin";
            Console.WriteLine("This program does various I/O things.");
            FileInfo aFile = null;
            FileStream fileStream = null;
            FileInfo anotherFile = null;
            BinaryWriter binaryWriter = null;

            FileInfo anotherFile1 = null;
            BinaryReader binaryReader = null;

            try
            {
                anotherFile1 = new FileInfo(binFileName);
                binaryReader = new BinaryReader(anotherFile1.OpenRead());
                Console.WriteLine("First binary object is: " + binaryReader.ReadInt32());
                Console.WriteLine("Second binary object is: " + binaryReader.ReadDouble());
                binaryReader.Close();

                aFile = new FileInfo(fileName);
                fileStream = aFile.Open(FileMode.CreateNew, FileAccess.ReadWrite, FileShare.None);

                anotherFile = new FileInfo(binFileName);
                binaryWriter = new BinaryWriter(anotherFile.OpenWrite());
                binaryWriter.Write(1234);
                binaryWriter.Write(45456.556);
                binaryWriter.Flush();

                System.IO.DirectoryInfo dir = new System.IO.DirectoryInfo(@"C:\");

                dir.CreateSubdirectory(directoryName);

                foreach (System.IO.FileInfo file in dir.GetFiles("*.*"))
                {
                    Console.WriteLine("{0}, {1}", file.Name, file.Length);
                }
                Console.ReadLine();
            }
            catch (IOException exception)
            {
                Console.WriteLine("Got an exception:" + exception.Message);
                Console.ReadLine();
            }
            finally
            {
                if (Directory.Exists(@"C:\" + directoryName))
                {
                    Directory.Delete(@"C:\" + directoryName);
                }

                if (fileStream != null)
                {
                    fileStream.Close();
                }

                if (aFile != null)
                {
                    aFile.Delete();
                }

                if (binaryWriter != null)
                {
                    binaryWriter.Close();
                }

                if (anotherFile != null)
                {
                    //anotherFile.Delete();
                }
            }
        }
    }
}
